<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="X-UA-Compatible" content="IE=Edge" />
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>Motor &#8212; Mindstorms EV3 Toolbox v1.0 documentation</title>
    <link rel="stylesheet" href="_static/bootstrap-sphinx.css" type="text/css" />
    <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
    <script type="text/javascript" id="documentation_options" data-url_root="./" src="_static/documentation_options.js"></script>
    <script type="text/javascript" src="_static/jquery.js"></script>
    <script type="text/javascript" src="_static/underscore.js"></script>
    <script type="text/javascript" src="_static/doctools.js"></script>
    <script type="text/javascript" src="_static/language_data.js"></script>
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="next" title="Sensor" href="Sensor.html" />
    <link rel="prev" title="EV3" href="EV3.html" />
<meta charset='utf-8'>
<meta http-equiv='X-UA-Compatible' content='IE=edge,chrome=1'>
<meta name='viewport' content='width=device-width, initial-scale=1.0, maximum-scale=1'>
<meta name="apple-mobile-web-app-capable" content="yes">
<script type="text/javascript" src="_static/js/jquery-1.11.0.min.js "></script>
<script type="text/javascript" src="_static/js/jquery-fix.js "></script>
<script type="text/javascript" src="_static/bootstrap-3.3.7/js/bootstrap.min.js "></script>
<script type="text/javascript" src="_static/bootstrap-sphinx.js "></script>

  </head><body>

  <div id="navbar" class="navbar navbar-default navbar-fixed-top">
    <div class="container">
      <div class="navbar-header">
        <!-- .btn-navbar is used as the toggle for collapsed navbar content -->
        <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".nav-collapse">
          <span class="icon-bar"></span>
          <span class="icon-bar"></span>
          <span class="icon-bar"></span>
        </button>
        <a class="navbar-brand" href="index.html">
          Mindstorms EV3 Toolbox</a>
        <span class="navbar-text navbar-version pull-left"><b>v1.0</b></span>
      </div>

        <div class="collapse navbar-collapse nav-collapse">
          <ul class="nav navbar-nav">
            
            
              <li class="dropdown globaltoc-container">
  <a role="button"
     id="dLabelGlobalToc"
     data-toggle="dropdown"
     data-target="#"
     href="index.html">Site <b class="caret"></b></a>
  <ul class="dropdown-menu globaltoc"
      role="menu"
      aria-labelledby="dLabelGlobalToc"><ul class="current">
<li class="toctree-l1"><a class="reference internal" href="EV3.html">EV3</a></li>
<li class="toctree-l1 current"><a class="current reference internal" href="#">Motor</a></li>
<li class="toctree-l1"><a class="reference internal" href="Sensor.html">Sensor</a></li>
</ul>
<ul>
<li class="toctree-l1"><a class="reference internal" href="hid.html">hidapi</a></li>
<li class="toctree-l1"><a class="reference internal" href="usbBrickIO.html">usbBrickIO</a></li>
<li class="toctree-l1"><a class="reference internal" href="btBrickIO.html">btBrickIO</a></li>
</ul>
</ul>
</li>
              
                <li class="dropdown">
  <a role="button"
     id="dLabelLocalToc"
     data-toggle="dropdown"
     data-target="#"
     href="#">Page <b class="caret"></b></a>
  <ul class="dropdown-menu localtoc"
      role="menu"
      aria-labelledby="dLabelLocalToc"><ul>
<li><a class="reference internal" href="#">Motor</a></li>
</ul>
</ul>
</li>
              
            
            
              
                
  <li>
    <a href="EV3.html" title="Previous Chapter: EV3"><span class="glyphicon glyphicon-chevron-left visible-sm"></span><span class="hidden-sm hidden-tablet">&laquo; EV3</span>
    </a>
  </li>
  <li>
    <a href="Sensor.html" title="Next Chapter: Sensor"><span class="glyphicon glyphicon-chevron-right visible-sm"></span><span class="hidden-sm hidden-tablet">Sensor &raquo;</span>
    </a>
  </li>
              
            
            
            
            
              <li class="hidden-sm">
<div id="sourcelink">
  <a href="_sources/Motor.rst.txt"
     rel="nofollow">Source</a>
</div></li>
            
          </ul>

          
            
<form class="navbar-form navbar-right" action="search.html" method="get">
 <div class="form-group">
  <input type="text" name="q" class="form-control" placeholder="Search" />
 </div>
  <input type="hidden" name="check_keywords" value="yes" />
  <input type="hidden" name="area" value="default" />
</form>
          
        </div>
    </div>
  </div>

<div class="container">
  <div class="row">
    <div class="body col-md-12 content" role="main">
      
  <span class="target" id="module-source"></span><div class="section" id="motor">
<h1>Motor<a class="headerlink" href="#motor" title="Permalink to this headline">¶</a></h1>
<dl class="class">
<dt id="source.Motor">
<em class="property">class </em><code class="descname">Motor</code><span class="sig-paren">(</span><em>varargin</em><span class="sig-paren">)</span><a class="headerlink" href="#source.Motor" title="Permalink to this definition">¶</a></dt>
<dd><dl class="docutils">
<dt><em>List of methods</em>:</dt>
<dd><ul class="first last simple">
<li><a class="reference internal" href="#source.Motor.start" title="source.Motor.start"><code class="xref mat mat-meth docutils literal notranslate"><span class="pre">start()</span></code></a></li>
<li><a class="reference internal" href="#source.Motor.stop" title="source.Motor.stop"><code class="xref mat mat-meth docutils literal notranslate"><span class="pre">stop()</span></code></a></li>
<li><a class="reference internal" href="#source.Motor.syncedStart" title="source.Motor.syncedStart"><code class="xref mat mat-meth docutils literal notranslate"><span class="pre">syncedStart()</span></code></a></li>
<li><a class="reference internal" href="#source.Motor.syncedStop" title="source.Motor.syncedStop"><code class="xref mat mat-meth docutils literal notranslate"><span class="pre">syncedStop()</span></code></a></li>
<li><a class="reference internal" href="#source.Motor.waitFor" title="source.Motor.waitFor"><code class="xref mat mat-meth docutils literal notranslate"><span class="pre">waitFor()</span></code></a></li>
<li><a class="reference internal" href="#source.Motor.internalReset" title="source.Motor.internalReset"><code class="xref mat mat-meth docutils literal notranslate"><span class="pre">internalReset()</span></code></a></li>
<li><a class="reference internal" href="#source.Motor.resetTachoCount" title="source.Motor.resetTachoCount"><code class="xref mat mat-meth docutils literal notranslate"><span class="pre">resetTachoCount()</span></code></a></li>
<li><a class="reference internal" href="#source.Motor.setBrake" title="source.Motor.setBrake"><code class="xref mat mat-meth docutils literal notranslate"><span class="pre">setBrake()</span></code></a></li>
<li><a class="reference internal" href="#source.Motor.setProperties" title="source.Motor.setProperties"><code class="xref mat mat-meth docutils literal notranslate"><span class="pre">setProperties()</span></code></a></li>
</ul>
</dd>
</dl>
<p>High-level class to work with motors.</p>
<p>This class is supposed to ease the use of the brick’s motors. It is possible to set all
kinds of parameters, request the current status of the motor ports and of course send
commands to the brick to be executed on the respective port.</p>
<p class="rubric">Notes</p>
<ul class="simple">
<li>You don’t need to create instances of this class. The EV3-class automatically creates
instances for each motor port, and you can work with them via the EV3-object.</li>
<li>The Motor-class represents motor ports, not individual motors!</li>
<li>If you start a motor with power=0, the internal state will still be set to
‘isRunning’</li>
<li>When an input argument of a method is marked as optional, the argument needs to be
‘announced’ by a preceding 2nd argument, which is a string containing the name of the argument.
For example, Motor.setProperties may be given a power-parameter. The syntax would be as
follows: <em>brickObject.motorA.setProperties(‘power’, 50);</em></li>
</ul>
<dl class="attribute">
<dt id="source.Motor.power">
<code class="descname">power</code><a class="headerlink" href="#source.Motor.power" title="Permalink to this definition">¶</a></dt>
<dd><p>Power level of motor in percent. <em>[WRITABLE]</em></p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Type:</th><td class="field-body">numeric in [-100, 100]</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="attribute">
<dt id="source.Motor.speedRegulation">
<code class="descname">speedRegulation</code><a class="headerlink" href="#source.Motor.speedRegulation" title="Permalink to this definition">¶</a></dt>
<dd><p>Speed regulation turned on or off. When turned on, motor will
try to ‘hold’ its speed at given power level, whatever the load. In this mode, the
highest possible speed depends on the load and mostly goes up to around 70-80 (at
this point, the Brick internally inputs 100% power). When turned off, motor will
constantly input the same power into the motor. The resulting speed will be
somewhat lower, depending on the load. <em>[WRITABLE]</em></p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Type:</th><td class="field-body">bool</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="attribute">
<dt id="source.Motor.smoothStart">
<code class="descname">smoothStart</code><a class="headerlink" href="#source.Motor.smoothStart" title="Permalink to this definition">¶</a></dt>
<dd><p>Degrees/Time
indicating how far/long the motor should smoothly start. Depending on limitMode,
the input is interpreted either in degrees or milliseconds. The first
{smoothStart}-milliseconds/degrees of limitValue the motor will slowly accelerate
until reaching its defined speed. See also <a class="reference internal" href="#source.Motor.limitValue" title="source.Motor.limitValue"><code class="xref mat mat-attr docutils literal notranslate"><span class="pre">limitValue</span></code></a>, <a class="reference internal" href="#source.Motor.limitMode" title="source.Motor.limitMode"><code class="xref mat mat-attr docutils literal notranslate"><span class="pre">limitMode</span></code></a>. <em>[WRITABLE]</em></p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Type:</th><td class="field-body">numeric s. t. smoothStart+smoothStop &lt; limitValue</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="attribute">
<dt id="source.Motor.smoothStop">
<code class="descname">smoothStop</code><a class="headerlink" href="#source.Motor.smoothStop" title="Permalink to this definition">¶</a></dt>
<dd><p>Degrees/Time
indicating how far/long the motor should smoothly stop. Depending on limitMode, the
input is interpreted either in degrees or milliseconds. The last
[smoothStop]-milliseconds/degrees of limitValue the motor will slowly slow down
until it has stopped. See also <a class="reference internal" href="#source.Motor.limitValue" title="source.Motor.limitValue"><code class="xref mat mat-attr docutils literal notranslate"><span class="pre">limitValue</span></code></a>, <a class="reference internal" href="#source.Motor.limitMode" title="source.Motor.limitMode"><code class="xref mat mat-attr docutils literal notranslate"><span class="pre">limitMode</span></code></a>. <em>[WRITABLE]</em></p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Type:</th><td class="field-body">numeric s. t. smoothStart+smoothStop &lt; limitValue</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="attribute">
<dt id="source.Motor.limitValue">
<code class="descname">limitValue</code><a class="headerlink" href="#source.Motor.limitValue" title="Permalink to this definition">¶</a></dt>
<dd><p>Degrees/Time indicating how far/long the motor should run.
Depending on limitMode, the input is interpreted either in degrees or
milliseconds. See also <a class="reference internal" href="#source.Motor.limitMode" title="source.Motor.limitMode"><code class="xref mat mat-attr docutils literal notranslate"><span class="pre">limitMode</span></code></a>. <em>[WRITABLE]</em></p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Type:</th><td class="field-body">numeric&gt;=0</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="attribute">
<dt id="source.Motor.limitMode">
<code class="descname">limitMode</code><a class="headerlink" href="#source.Motor.limitMode" title="Permalink to this definition">¶</a></dt>
<dd><p>Mode for motor limit. See also <a class="reference internal" href="#source.Motor.limitValue" title="source.Motor.limitValue"><code class="xref mat mat-attr docutils literal notranslate"><span class="pre">limitValue</span></code></a>. <em>[WRITABLE]</em></p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Type:</th><td class="field-body">‘Tacho’|’Time’</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="attribute">
<dt id="source.Motor.brakeMode">
<code class="descname">brakeMode</code><a class="headerlink" href="#source.Motor.brakeMode" title="Permalink to this definition">¶</a></dt>
<dd><p>Action done when stopping. If ‘Coast’, the motor will (at
tacholimit, if ~=0) coast to a stop. If ‘Brake’, the motor will stop immediately
(at tacholimit, if ~=0) and hold the brake. <em>[WRITABLE]</em></p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Type:</th><td class="field-body">‘Brake’|’Coast’</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="attribute">
<dt id="source.Motor.debug">
<code class="descname">debug</code><a class="headerlink" href="#source.Motor.debug" title="Permalink to this definition">¶</a></dt>
<dd><p>Debug turned on or off. In debug mode, everytime a command is passed to
the sublayer (‘communication layer’), there is feedback in the console about what
command has been called. <em>[WRITABLE]</em></p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Type:</th><td class="field-body">bool</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="attribute">
<dt id="source.Motor.isRunning">
<code class="descname">isRunning</code><a class="headerlink" href="#source.Motor.isRunning" title="Permalink to this definition">¶</a></dt>
<dd><p>True if motor is running. <em>[READ-ONLY]</em></p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Type:</th><td class="field-body">bool</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="attribute">
<dt id="source.Motor.tachoCount">
<code class="descname">tachoCount</code><a class="headerlink" href="#source.Motor.tachoCount" title="Permalink to this definition">¶</a></dt>
<dd><p>Current tacho count in degrees. <em>[READ-ONLY]</em></p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Type:</th><td class="field-body">numeric</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="attribute">
<dt id="source.Motor.currentSpeed">
<code class="descname">currentSpeed</code><a class="headerlink" href="#source.Motor.currentSpeed" title="Permalink to this definition">¶</a></dt>
<dd><p>Current speed of motor. If speedRegulation=on this should equal power,
otherwise it will probably be lower than that. See also <a class="reference internal" href="#source.Motor.speedRegulation" title="source.Motor.speedRegulation"><code class="xref mat mat-attr docutils literal notranslate"><span class="pre">speedRegulation</span></code></a>. <em>[READ-ONLY]</em></p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Type:</th><td class="field-body">numeric</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="attribute">
<dt id="source.Motor.type">
<code class="descname">type</code><a class="headerlink" href="#source.Motor.type" title="Permalink to this definition">¶</a></dt>
<dd><p>Type of connected device if any. <em>[READ-ONLY]</em></p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Type:</th><td class="field-body">DeviceType</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="method">
<dt id="source.Motor.internalReset">
<code class="descname">internalReset</code><span class="sig-paren">(</span><em>motor</em><span class="sig-paren">)</span><a class="headerlink" href="#source.Motor.internalReset" title="Permalink to this definition">¶</a></dt>
<dd><p>Resets internal tacho count. Use this if motor behaves weird (i.e. not starting at all, or not correctly
running to limitValue).</p>
<p>The internal tacho count is used for positioning the motor. When the
motor is running with a tacho limit, internally it uses another counter than the
one read by tachoCount. This internal tacho count needs to be reset if you
physically change the motor’s position or it coasted into a stop. If the motor’s
brakemode is ‘Coast’, this function is called automatically.</p>
<p class="rubric">Notes</p>
<ul class="simple">
<li>A better name would probably be resetPosition…</li>
<li>Gets called automatically when starting the motor and the internal tacho count is &gt; 0</li>
</ul>
<p>See also MOTOR.RESETTACHOCOUNT / <a class="reference internal" href="#source.Motor.resetTachoCount" title="source.Motor.resetTachoCount"><code class="xref mat mat-attr docutils literal notranslate"><span class="pre">resetTachoCount</span></code></a></p>
</dd></dl>

<dl class="method">
<dt id="source.Motor.resetTachoCount">
<code class="descname">resetTachoCount</code><span class="sig-paren">(</span><em>motor</em><span class="sig-paren">)</span><a class="headerlink" href="#source.Motor.resetTachoCount" title="Permalink to this definition">¶</a></dt>
<dd><p>Resets tachocount.</p>
<p>See also MOTOR.TACHOCOUNT / <a class="reference internal" href="#source.Motor.tachoCount" title="source.Motor.tachoCount"><code class="xref mat mat-attr docutils literal notranslate"><span class="pre">tachoCount</span></code></a></p>
</dd></dl>

<dl class="method">
<dt id="source.Motor.setBrake">
<code class="descname">setBrake</code><span class="sig-paren">(</span><em>motor</em>, <em>brake</em><span class="sig-paren">)</span><a class="headerlink" href="#source.Motor.setBrake" title="Permalink to this definition">¶</a></dt>
<dd><p>Apply or release brake of motor.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><strong>brake</strong> (<em>bool</em>) – If true, brake will be pulled</td>
</tr>
</tbody>
</table>
<p class="rubric">Notes</p>
<ul class="simple">
<li>This method does not affect Motor.brakeMode. After the next run, the motor
will again be stopped as specified in Motor.brakeMode.</li>
</ul>
<p>See also MOTOR.BRAKEMODE / <a class="reference internal" href="#source.Motor.brakeMode" title="source.Motor.brakeMode"><code class="xref mat mat-attr docutils literal notranslate"><span class="pre">brakeMode</span></code></a></p>
</dd></dl>

<dl class="method">
<dt id="source.Motor.setProperties">
<code class="descname">setProperties</code><span class="sig-paren">(</span><em>motor</em>, <em>varargin</em><span class="sig-paren">)</span><a class="headerlink" href="#source.Motor.setProperties" title="Permalink to this definition">¶</a></dt>
<dd><p>Sets multiple Motor properties at once using MATLAB’s inputParser.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><ul class="first last simple">
<li><strong>debug</strong> (<em>bool</em>) – <em>[OPTIONAL]</em></li>
<li><strong>smoothStart</strong> (<em>numeric in [0, limitValue]</em>) – <em>[OPTIONAL]</em></li>
<li><strong>smoothStop</strong> (<em>numeric in [0, limitValue]</em>) – <em>[OPTIONAL]</em></li>
<li><strong>speedRegulation</strong> (<em>bool</em>) – <em>[OPTIONAL]</em></li>
<li><strong>brakeMode</strong> (<em>'Coast'|'Brake'</em>) – <em>[OPTIONAL]</em></li>
<li><strong>limitMode</strong> (<em>'Time'|'Tacho'</em>) – <em>[OPTIONAL]</em></li>
<li><strong>limitValue</strong> (<em>numeric &gt; 0</em>) – <em>[OPTIONAL]</em></li>
<li><strong>power</strong> (<em>numeric in [-100,100]</em>) – <em>[OPTIONAL]</em></li>
<li><strong>batteryMode</strong> (<em>'Voltage'|'Percentage'</em>) – <em>[OPTIONAL]</em></li>
</ul>
</td>
</tr>
</tbody>
</table>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">Example</span><span class="p">:</span>
    <span class="n">brick</span> <span class="o">=</span> <span class="n">EV3</span><span class="p">();</span>
    <span class="n">brick</span><span class="o">.</span><span class="n">connect</span><span class="p">(</span><span class="s1">&#39;bt&#39;</span><span class="p">,</span> <span class="s1">&#39;serPort&#39;</span><span class="p">,</span> <span class="s1">&#39;/dev/rfcomm0&#39;</span><span class="p">);</span>
    <span class="n">brick</span><span class="o">.</span><span class="n">motorA</span><span class="o">.</span><span class="n">setProperties</span><span class="p">(</span><span class="s1">&#39;debug&#39;</span><span class="p">,</span> <span class="s1">&#39;on&#39;</span><span class="p">,</span> <span class="s1">&#39;power&#39;</span><span class="p">,</span> <span class="mi">50</span><span class="p">,</span> <span class="s1">&#39;limitValue&#39;</span><span class="p">,</span> <span class="mi">720</span><span class="p">,</span> <span class="s1">&#39;speedRegulation&#39;</span><span class="p">,</span> <span class="s1">&#39;on&#39;</span><span class="p">);</span>
    <span class="o">%</span> <span class="n">Instead</span> <span class="n">of</span><span class="p">:</span> <span class="n">brick</span><span class="o">.</span><span class="n">motorA</span><span class="o">.</span><span class="n">debug</span> <span class="o">=</span> <span class="s1">&#39;on&#39;</span><span class="p">;</span>
    <span class="o">%</span>             <span class="n">brick</span><span class="o">.</span><span class="n">motorA</span><span class="o">.</span><span class="n">power</span> <span class="o">=</span> <span class="mi">50</span><span class="p">;</span>
    <span class="o">%</span>             <span class="n">brick</span><span class="o">.</span><span class="n">motorA</span><span class="o">.</span><span class="n">limitValue</span> <span class="o">=</span> <span class="mi">720</span><span class="p">;</span>
    <span class="o">%</span>             <span class="n">brick</span><span class="o">.</span><span class="n">motorA</span><span class="o">.</span><span class="n">speedRegulation</span> <span class="o">=</span> <span class="s1">&#39;on&#39;</span><span class="p">;</span>
</pre></div>
</div>
</dd></dl>

<dl class="method">
<dt id="source.Motor.start">
<code class="descname">start</code><span class="sig-paren">(</span><em>motor</em><span class="sig-paren">)</span><a class="headerlink" href="#source.Motor.start" title="Permalink to this definition">¶</a></dt>
<dd><p>Starts the motor.</p>
</dd></dl>

<dl class="method">
<dt id="source.Motor.stop">
<code class="descname">stop</code><span class="sig-paren">(</span><em>motor</em><span class="sig-paren">)</span><a class="headerlink" href="#source.Motor.stop" title="Permalink to this definition">¶</a></dt>
<dd><p>Stops the motor.</p>
<p class="rubric">Notes</p>
<ul class="simple">
<li>If this motor has been started synced with another one (either as master or
slave, using Motor.syncedStart), syncedStop() will be called, stopping both
motors.</li>
</ul>
<p>See also MOTOR.START, MOTOR.SYNCEDSTOP / <a class="reference internal" href="#source.Motor.start" title="source.Motor.start"><code class="xref mat mat-meth docutils literal notranslate"><span class="pre">start()</span></code></a>, <a class="reference internal" href="#source.Motor.syncedStop" title="source.Motor.syncedStop"><code class="xref mat mat-meth docutils literal notranslate"><span class="pre">syncedStop()</span></code></a></p>
</dd></dl>

<dl class="method">
<dt id="source.Motor.syncedStart">
<code class="descname">syncedStart</code><span class="sig-paren">(</span><em>motor</em>, <em>syncMotor</em>, <em>varargin</em><span class="sig-paren">)</span><a class="headerlink" href="#source.Motor.syncedStart" title="Permalink to this definition">¶</a></dt>
<dd><p>Starts this motor synchronized with another.</p>
<blockquote>
<div><p>The motor, with which this method is called, acts as a <em>master</em>, meaning that the
synchronized control is done with it und uses its parameters. When syncedStart is
called, the master sets some of the slave’s (syncMotor) properties to keep it
consistent with the physical brick. So, for example, if the master has another
power-value than the slave, the slave’s power-value will be set to that of the
master when syncedStart() is called.
The following parameters will be affected on the slave: <em>power</em>, <em>brakeMode</em>,
<em>limitValue</em>, <em>speedRegulation</em></p>
<dl class="docutils">
<dt>Arguments:</dt>
<dd><p class="first">syncMotor (Motor): The motor-object to sync with
turnRatio (numeric in [-200,200]): Ratio between the two master’s and the</p>
<blockquote class="last">
<div>slave’s motor speed. With values!=0 one motor will be slower than the other
or even turn into the other direction. This can be used for turning car-like
robots, for example. <em>[OPTIONAL]</em> (Read in Firmware-comments in c_output.c): <br />
-&gt; 0 is moving straight forward <br />
-&gt; Negative values turn to the left <br />
-&gt; Positive values turn to the right <br />
-&gt; Value -100 stops the left motor <br />
-&gt; Value +100 stops the right motor <br />
-&gt; Values less than -100 makes the left motor run the opposite direction of the right motor (Spin) <br />
-&gt; Values greater than +100 makes the right motor run the opposite direction of the left motor (Spin) <br /></div></blockquote>
</dd>
<dt>Notes:</dt>
<dd><ul class="first last simple">
<li>This is a pretty ‘heavy’ function, as it tests if both motors are
connected AND aren’t running, wasting four packets, keep that in mind.</li>
</ul>
</dd>
</dl>
</div></blockquote>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>    Example:
        brick = EV3();
        brick.connect(&#39;usb&#39;);
        motor = brick.motorA;
        slave = brick.motorB;
        motor.power = 50;
        motor.syncedStart(slave);
        % Do stuff
        motor.stop();

See also MOTOR.STOP, MOTOR.SYNCEDSTOP / :meth:`stop`, :meth:`syncedStop`
</pre></div>
</div>
</dd></dl>

<dl class="method">
<dt id="source.Motor.syncedStop">
<code class="descname">syncedStop</code><span class="sig-paren">(</span><em>motor</em><span class="sig-paren">)</span><a class="headerlink" href="#source.Motor.syncedStop" title="Permalink to this definition">¶</a></dt>
<dd><p>Stops both motors previously started with syncedStart.</p>
<p class="rubric">Notes</p>
<ul class="simple">
<li>This method is called automatically by stop(), if the motors have been
started using syncedStart, and the regular stop-method has been called afterwards.</li>
</ul>
<p>See also MOTOR.SYNCEDSTART, MOTOR.STOP / <a class="reference internal" href="#source.Motor.syncedStart" title="source.Motor.syncedStart"><code class="xref mat mat-meth docutils literal notranslate"><span class="pre">syncedStart()</span></code></a>, <a class="reference internal" href="#source.Motor.stop" title="source.Motor.stop"><code class="xref mat mat-meth docutils literal notranslate"><span class="pre">stop()</span></code></a></p>
</dd></dl>

<dl class="method">
<dt id="source.Motor.waitFor">
<code class="descname">waitFor</code><span class="sig-paren">(</span><em>motor</em><span class="sig-paren">)</span><a class="headerlink" href="#source.Motor.waitFor" title="Permalink to this definition">¶</a></dt>
<dd><p>Stops execution of program as long as motor is running.</p>
<p class="rubric">Notes</p>
<ul class="simple">
<li>This one’s a bit tricky. The opCode which is supposed to be used here, OutputReady,
makes the brick stop sending
responses until the motor has stopped. For security reasons, in this toolbox
there is an internal timeout for receiving messages from the brick. It raises
an error if a reply takes too long, which would happen in this case. As a
workaround, there is an infinite loop that catches errors from outputReady and
continues then, until outputReady will actually finish without an error.</li>
<li>Workaround: Poll isRunning until it is false (No need to check if motor is
connected as speed correctly returns 0 if it’s not)</li>
</ul>
</dd></dl>

</dd></dl>

</div>


    </div>
      
  </div>
</div>
<footer class="footer">
  <div class="container">
    <p class="pull-right">
      <a href="#">Back to top</a>
      
    </p>
    <p>
        &copy; Copyright 2017, RWTH Aachen.<br/>
      Created using <a href="http://sphinx-doc.org/">Sphinx</a> 1.8.5.<br/>
    </p>
  </div>
</footer>
  </body>
</html>